package com.ikanow.infinit.e.data_model.custom;

import java.io.DataInput;
import java.io.IOException;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.io.RawComparator;
import org.apache.hadoop.mapreduce.InputFormat;
import org.apache.hadoop.mapreduce.Mapper;
import org.apache.hadoop.mapreduce.OutputFormat;
import org.apache.hadoop.mapreduce.Partitioner;
import org.apache.hadoop.mapreduce.Reducer;

import com.mongodb.DBCollection;
import com.mongodb.DBObject;
import com.mongodb.MongoURI;

public class InfiniteMongoConfig 
{
	/**
     * You probably don't want to use this.
     */
    @Deprecated
    public InfiniteMongoConfig(){
        _conf = new Configuration();
    }

    public InfiniteMongoConfig( Configuration conf ){
        _conf = conf;
    }

    public InfiniteMongoConfig( DataInput in ) throws IOException
    {
        _conf = new Configuration();
        _conf.readFields( in );
    }

    public boolean isJobVerbose(){
        return InfiniteMongoConfigUtil.isJobVerbose( _conf );
    }

    public void setJobVerbose( boolean val ){
    	InfiniteMongoConfigUtil.setJobVerbose( _conf, val );
    }

    public boolean isJobBackground(){
        return InfiniteMongoConfigUtil.isJobBackground( _conf );
    }

    public void setJobBackground( boolean val ){
    	InfiniteMongoConfigUtil.setJobBackground( _conf, val );
    }

    public Class<? extends Mapper> getMapper(){
        return InfiniteMongoConfigUtil.getMapper( _conf );
    }

    public void setMapper( Class<? extends Mapper> val ){
    	InfiniteMongoConfigUtil.setMapper( _conf, val );
    }

    public Class<?> getMapperOutputKey(){
        return InfiniteMongoConfigUtil.getMapperOutputKey( _conf );
    }

    public void setMapperOutputKey( Class<?> val ){
    	InfiniteMongoConfigUtil.setMapperOutputKey( _conf, val );
    }

    public Class<?> getMapperOutputValue(){
        return InfiniteMongoConfigUtil.getMapperOutputValue( _conf );
    }

    public void setMapperOutputValue( Class<?> val ){
    	InfiniteMongoConfigUtil.setMapperOutputKey( _conf, val );
    }

    public Class<? extends Reducer> getCombiner(){
        return InfiniteMongoConfigUtil.getCombiner( _conf );
    }

    public void setCombiner( Class<? extends Reducer> val ){
        InfiniteMongoConfigUtil.setCombiner( _conf, val );
    }

    public Class<? extends Reducer> getReducer(){
        return InfiniteMongoConfigUtil.getReducer( _conf );
    }

    public void setReducer( Class<? extends Reducer> val ){
        InfiniteMongoConfigUtil.setReducer( _conf, val );
    }

    public Class<? extends Partitioner> getPartitioner(){
        return InfiniteMongoConfigUtil.getPartitioner( _conf );
    }

    public void setPartitioner( Class<? extends Partitioner> val ){
        InfiniteMongoConfigUtil.setPartitioner( _conf, val );
    }

    public Class<? extends RawComparator> getSortComparator(){
        return InfiniteMongoConfigUtil.getSortComparator( _conf );
    }

    public void setSortComparator( Class<? extends RawComparator> val ){
        InfiniteMongoConfigUtil.setSortComparator( _conf, val );
    }

    public Class<? extends OutputFormat> getOutputFormat(){
        return InfiniteMongoConfigUtil.getOutputFormat( _conf );
    }

    public void setOutputFormat( Class<? extends OutputFormat> val ){
        InfiniteMongoConfigUtil.setOutputFormat( _conf, val );
    }

    public Class<?> getOutputKey(){
        return InfiniteMongoConfigUtil.getOutputKey( _conf );
    }

    public void setOutputKey( Class<?> val ){
        InfiniteMongoConfigUtil.setOutputKey( _conf, val );
    }

    public Class<?> getOutputValue(){
        return InfiniteMongoConfigUtil.getOutputValue( _conf );
    }

    public void setOutputValue( Class<?> val ){
        InfiniteMongoConfigUtil.setOutputValue( _conf, val );
    }

    public Class<? extends InputFormat> getInputFormat(){
        return InfiniteMongoConfigUtil.getInputFormat( _conf );
    }

    public void setInputFormat( Class<? extends InputFormat> val ){
        InfiniteMongoConfigUtil.setInputFormat( _conf, val );
    }

    public MongoURI getMongoURI( String key ){
        return InfiniteMongoConfigUtil.getMongoURI( _conf, key );
    }

    public MongoURI getInputURI(){
        return InfiniteMongoConfigUtil.getInputURI( _conf );
    }

    public DBCollection getOutputCollection(){
        return InfiniteMongoConfigUtil.getOutputCollection( _conf );
    }

    public DBCollection getInputCollection(){
        return InfiniteMongoConfigUtil.getInputCollection( _conf );
    }

    public void setMongoURI( String key, MongoURI value ){
        InfiniteMongoConfigUtil.setMongoURI( _conf, key, value );
    }

    public void setMongoURIString( String key, String value ){
        InfiniteMongoConfigUtil.setMongoURIString( _conf, key, value );
    }

    public void setInputURI( String uri ){
        InfiniteMongoConfigUtil.setInputURI( _conf, uri );
    }

    public void setInputURI( MongoURI uri ){
        InfiniteMongoConfigUtil.setInputURI( _conf, uri );
    }

    public MongoURI getOutputURI(){
        return InfiniteMongoConfigUtil.getOutputURI( _conf );
    }

    public void setOutputURI( String uri ){
        InfiniteMongoConfigUtil.setOutputURI( _conf, uri );
    }

    public void setOutputURI( MongoURI uri ){
        InfiniteMongoConfigUtil.setOutputURI( _conf, uri );
    }

    /**
     * Set JSON but first validate it's parseable into a BSON Object
     */
    public void setJSON( String key, String value ){
        InfiniteMongoConfigUtil.setJSON( _conf, key, value );
    }

    public DBObject getDBObject( String key ){
        return InfiniteMongoConfigUtil.getDBObject( _conf, key );
    }

    public void setDBObject( String key, DBObject value ){
        InfiniteMongoConfigUtil.setDBObject( _conf, key, value );
    }

    public void setQuery( String query ){
        InfiniteMongoConfigUtil.setQuery( _conf, query );
    }

    public void setQuery( DBObject query ){
        InfiniteMongoConfigUtil.setQuery( _conf, query );
    }

    public DBObject getQuery(){
        return InfiniteMongoConfigUtil.getQuery( _conf );
    }

    public void setFields( String fields ){
        InfiniteMongoConfigUtil.setFields( _conf, fields );
    }

    public void setFields( DBObject fields ){
        InfiniteMongoConfigUtil.setFields( _conf, fields );
    }

    public DBObject getFields(){
        return InfiniteMongoConfigUtil.getFields( _conf );
    }

    public void setSort( String sort ){
        InfiniteMongoConfigUtil.setSort( _conf, sort );
    }

    public void setSort( DBObject sort ){
        InfiniteMongoConfigUtil.setSort( _conf, sort );
    }

    public DBObject getSort(){
        return InfiniteMongoConfigUtil.getSort( _conf );
    }
    
    public int getMaxSplits(){
        return InfiniteMongoConfigUtil.getMaxSplits( _conf );
    }

    public void setMaxSplits( int max_splits ){
        InfiniteMongoConfigUtil.setMaxSplits( _conf, max_splits );
    }
    
    public int getMaxDocsPerSplit(){
        return InfiniteMongoConfigUtil.getMaxDocsPerSplit( _conf );
    }

    public void setMaxDocsPerSplit( int max_docs_per_split ){
        InfiniteMongoConfigUtil.setMaxDocsPerSplit( _conf, max_docs_per_split );
    }

    public int getLimit(){
        return InfiniteMongoConfigUtil.getLimit( _conf );
    }

    public void setLimit( int limit ){
        InfiniteMongoConfigUtil.setLimit( _conf, limit );
    }

    public int getSkip(){
        return InfiniteMongoConfigUtil.getSkip( _conf );
    }

    public void setSkip( int skip ){
        InfiniteMongoConfigUtil.setSkip( _conf, skip );
    }

    public int getSplitSize(){
        return InfiniteMongoConfigUtil.getSplitSize( _conf );
    }

    public void setSplitSize( int value ){
        InfiniteMongoConfigUtil.setSplitSize( _conf, value );
    }

    /**
     * if TRUE,
     * Splits will be read by connecting to the individual shard servers,
     *  however this really isn't safe unless you know what you're doing.
     *  ( issue has to do with chunks moving / relocating during balancing phases)
     * @return
     */
   public boolean canReadSplitsFromShards() {
        return InfiniteMongoConfigUtil.canReadSplitsFromShards( _conf );
    }

    public void setReadSplitsFromShards( boolean value ){
        InfiniteMongoConfigUtil.setReadSplitsFromShards( _conf, value );
    }

    /**
     * If sharding is enabled,
     * Use the sharding configured chunks to split up data.
     */
    public boolean isShardChunkedSplittingEnabled() {
        return InfiniteMongoConfigUtil.isShardChunkedSplittingEnabled( _conf );
    }

    public void setShardChunkSplittingEnabled( boolean value) {
        InfiniteMongoConfigUtil.setShardChunkSplittingEnabled( _conf, value );
    }

    public boolean canReadSplitsFromSecondary() {
        return InfiniteMongoConfigUtil.canReadSplitsFromSecondary( _conf );
    }

    public void setReadSplitsFromSecondary( boolean value ) {
        InfiniteMongoConfigUtil.setReadSplitsFromSecondary( _conf, value );
    }
    
    /**
     * If CREATE_INPUT_SPLITS is true but SPLITS_USE_CHUNKS is false, Mongo-Hadoop will attempt
     * to create custom input splits for you.  By default it will split on {@code _id}, which is a
     * reasonable/sane default.
     *
     * If you want to customize that split point for efficiency reasons (such as different distribution)
     * you may set this to any valid field name. The restriction on this key name are the *exact same rules*
     * as when sharding an existing MongoDB Collection.  You must have an index on the field, and follow the other
     * rules outlined in the docs.
     *
     * This must be a JSON document, and not just a field name!
     *
     * @link http://www.mongodb.org/display/DOCS/Sharding+Introduction#ShardingIntroduction-ShardKeys
     */
    public String getInputSplitKeyPattern() {
        return InfiniteMongoConfigUtil.getInputSplitKeyPattern( _conf );
    }

    // Convenience by DBObject rather than "Pattern"
    public DBObject getInputSplitKey() {
        return InfiniteMongoConfigUtil.getInputSplitKey( _conf );
    }

    /**
     * If CREATE_INPUT_SPLITS is true but SPLITS_USE_CHUNKS is false, Mongo-Hadoop will attempt
     * to create custom input splits for you.  By default it will split on {@code _id}, which is a
     * reasonable/sane default.
     *
     * If you want to customize that split point for efficiency reasons (such as different distribution)
     * you may set this to any valid field name. The restriction on this key name are the *exact same rules*
     * as when sharding an existing MongoDB Collection.  You must have an index on the field, and follow the other
     * rules outlined in the docs.
     *
     * This must be a JSON document, and not just a field name!
     *
     * @link http://www.mongodb.org/display/DOCS/Sharding+Introduction#ShardingIntroduction-ShardKeys
     */
    public void setInputSplitKeyPattern( String pattern ) {
        InfiniteMongoConfigUtil.setInputSplitKeyPattern( _conf, pattern );
    }

    // Convenience by DBObject rather than "Pattern"
    public void setInputSplitKey( DBObject key ) {
        InfiniteMongoConfigUtil.setInputSplitKey( _conf, key );
    }
            
    /**
     * If {@code true}, the driver will attempt to split the MongoDB Input data (if reading from Mongo) into
     * multiple InputSplits to allow parallelism/concurrency in processing within Hadoop.  That is to say,
     * Hadoop will assign one InputSplit per mapper.
     *
     * This is {@code true} by default now, but if {@code false}, only one InputSplit (your whole collection) will be
     * assigned to Hadoop  severely reducing parallel mapping.
     */
    public boolean createInputSplits() {
        return InfiniteMongoConfigUtil.createInputSplits( _conf );
    }

    /**
     * If {@code true}, the driver will attempt to split the MongoDB Input data (if reading from Mongo) into
     * multiple InputSplits to allow parallelism/concurrency in processing within Hadoop.  That is to say,
     * Hadoop will assign one InputSplit per mapper.
     *
     * This is {@code true} by default now, but if {@code false}, only one InputSplit (your whole collection) will be
     * assigned to Hadoop  severely reducing parallel mapping.
     */
    public void setCreateInputSplits( boolean value ) {
        InfiniteMongoConfigUtil.setCreateInputSplits( _conf, value );
    }

    /**
     * The MongoDB field to read from for the Mapper Input.
     *
     * This will be fed to your mapper as the "Key" for the input.
     *
     * Defaults to {@code _id}
     */
    public String getInputKey() {
        return InfiniteMongoConfigUtil.getInputKey( _conf );
    }

    /**
     * The MongoDB field to read from for the Mapper Input.
     *
     * This will be fed to your mapper as the "Key" for the input.
     *
     * Defaults to {@code _id}
     */
    public void setInputKey( String fieldName ) {
        InfiniteMongoConfigUtil.setInputKey( _conf, fieldName );
    }
    
    public boolean isNoTimeout() {
        return InfiniteMongoConfigUtil.isNoTimeout( _conf );
    }
    
    public void setNoTimeout( boolean value ) {
        InfiniteMongoConfigUtil.setNoTimeout( _conf, value );
    }

    final Configuration _conf;
}
