package com.ikanow.infinit.e.data_model.custom;

import java.io.IOException;
import java.util.List;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.mapreduce.InputFormat;
import org.apache.hadoop.mapreduce.InputSplit;
import org.apache.hadoop.mapreduce.JobContext;
import org.apache.hadoop.mapreduce.RecordReader;
import org.apache.hadoop.mapreduce.TaskAttemptContext;
import org.bson.BSONObject;


public class InfiniteMongoInputFormat extends InputFormat<Object, BSONObject>
{

	@Override
	public RecordReader<Object, BSONObject> createRecordReader(InputSplit split,
			TaskAttemptContext context) throws IOException, InterruptedException 
	{
		if ( !( split instanceof InfiniteMongoInputSplit ) )
			throw new IllegalStateException("Creation of a new RecordReader requires an InfiniteMongoInputSplit instance.");
		
		final InfiniteMongoInputSplit mis = (InfiniteMongoInputSplit)split;
		
		return new InfiniteMongoRecordReader(mis);
	}

	@Override
	public List<InputSplit> getSplits(JobContext context) throws IOException,
			InterruptedException 
	{
		final Configuration hadoopConfiguration = context.getConfiguration();
		final InfiniteMongoConfig conf = new InfiniteMongoConfig( hadoopConfiguration );
		return InfiniteMongoSplitter.calculateSplits(conf);
	}

}
